#!/usr/bin/env bash

DOCDIR="/tmp/bohriumdocs"
BRANCH="master"
#BRANCH="ctiling"
CWD=`pwd`

if [ -d "$DOCDIR" ]; then       # Grab the repos
    echo "Already got repos, not cloning."
else
    git clone git@bitbucket.org:bohrium/bohrium.bitbucket.org.git $DOCDIR
    cd $DOCDIR
    git checkout $BRANCH
    cd $CWD
fi

doxygen Doxyfile                # Generate C++ docs
make html                       # Generate HTML via sphinx

cp -r build/html/* $DOCDIR      # Copy to repos
cp -r extras/* $DOCDIR/
cd $DOCDIR
git add .
git commit -a -m "Autogenerated docs."
git push                        # Send it off

